<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Radius Graph</title>
    <style>
        body,
        html,
        #network {
            width: 100%;
            height: 100%;
            max-width: 100%;
            overflow: hidden;
        }

        body {
            margin: 0;
        }

        .text {
            font: 12px sans-serif;
        }
    </style>
</head>
<body>
<div id="network"></div>

<script src="https://d3js.org/d3.v4.js"></script>

<script>
    const computePositions = (data) => {
        const nOfSpines = data.nodes.filter((x) => x.label.includes("spine")).length;

        const marginBetweenNodes = 140;
        let tofX = 80 + (nOfSpines / 4) * marginBetweenNodes, tofY = 100;
        let spineX = 80, spineY = 350;
        let leafX = 80, leafY = 600;
        let serverX = 80, serverY = 850;

        data.nodes.sort((a, b) => {
            let [typeA, n1A, n2A, n3A] = a.label.split('_');
            let [typeB, n1B, n2B, n3B] = b.label.split('_');

            if(typeA !== typeB)
                return (typeA > typeB) ? 1 : -1;

            let numberA = parseInt(n1A) * 100 + parseInt(n2A) * 10 + parseInt(n3A);
            let numberB = parseInt(n1B) * 100 + parseInt(n2B) * 10 + parseInt(n3B);

            return (numberA > numberB) ? 1 : ((numberB > numberA) ? -1 : 0);
        })
        .forEach((node) => {
            if (node.id.includes("spine")) {
                node.x = spineX;
                node.y = spineY;
                spineX += marginBetweenNodes;
            }
            if (node.id.includes("leaf")) {
                node.x = leafX;
                node.y = leafY;
                leafX += marginBetweenNodes;
            }
            if (node.id.includes("server")) {
                node.x = serverX;
                node.y = serverY;
                serverX += marginBetweenNodes;
            }
        });

        _computeTofPositions(data, tofX, tofY, marginBetweenNodes);

        return [spineX - marginBetweenNodes + 80, serverY];
    };
    const _computeTofPositions = (data, tofX, tofY, marginBetweenNodes) => {
        let byTofNumber = {};

        data.nodes.forEach((node) => {
            if (node.id.includes("tof")) {
                const tofName = node.id.split("_");
                const tofNumber = tofName[3];

                if (!(tofNumber in byTofNumber))
                    byTofNumber[tofNumber] = []

                byTofNumber[tofNumber].push(node);
            }
        });

        Object.keys(byTofNumber).forEach((key) => {
            byTofNumber[key].forEach((node) => {
                node.x = tofX;
                node.y = tofY;
                tofX += marginBetweenNodes;
            });
        });

        data.nOfTofsPerPlane = byTofNumber["1"].length;
    };
    const filterLinks = (data) => {
        const filteredLinks = [];
        data.links.forEach((link) => {
            if ((filteredLinks.find((x) => x.source == link.target && x.target == link.source) === undefined)) {
                if (!isNormalStarting) {
                    if (failedNeighbours.length > 0) {
                        if ((link.source === failedNode && failedNeighbours.find(y => y === link.target) !== undefined) ||
                            (failedNeighbours.find(y => y === link.source) !== undefined && link.target === failedNode))
                            return;
                    } else if (link.source === failedNode || link.target === failedNode)
                        return;
                }

                link.isTofRing = link.source.includes("tof") && link.target.includes("tof");
                filteredLinks.push(link);
            }
        });
        data.links = filteredLinks;
    };
    const centerX = (coord) => {
        return coord - (rectSizeX / 2);
    };
    const centerY = (coord) => {
        return coord - (rectSizeY / 2);
    };
    const findNode = (nodeName) => {
        return data.nodes.find((x) => x.label == nodeName);
    };
</script>

<script>
    const drawEdges = (links, g, colorMap, hPosition) => {
        g.selectAll(".edges")
            .data(links)
            .enter()
            .append("line")
            .attr("class", "edges")
            .attr("x1", (d) => findNode(d.source).x)
            .attr("y1", (d) => findNode(d.source).y)
            .attr("x2", (d) => findNode(d.target).x)
            .attr("y2", (d) => findNode(d.target).y)
            .attr("stroke-width", 1)
            .attr("stroke", (d) => colorMap[Math.round(colorScale(d.value))]);

        g.selectAll(".edgepath")
            .data(links)
            .enter()
            .append('path')
            .attr("class", "edgepath")
            .attr("d", (d) => {
                const startNode = findNode(d.source);
                const endNode = findNode(d.target);
                if (startNode.x > endNode.x)
                    return 'M ' + endNode.x + ' ' + endNode.y + ' L ' + startNode.x + ' ' + startNode.y;

                return 'M ' + startNode.x + ' ' + startNode.y + ' L ' + endNode.x + ' ' + endNode.y;
            })
            .attr("fill-opacity", 0)
            .attr("stroke-opacity", 0)
            .attr("id", (d, i) => "edgepath-" + d.source + "-" + d.target)
            .style("pointer-events", "none");

        g.selectAll(".edgelabels-shadow")
            .data(links)
            .enter()
            .append('text')
            .attr("class", "text edgelabels-shadow")
            .attr("dy", 4)
            .attr("stroke", "white")
            .attr("stroke-width", 3)
            .attr("fill", "white")
            .attr("font-size", "14px")
            .style("pointer-events", "none")
            .style("text-anchor", "middle")
            .append('textPath')
            .text((d, i) => d.value)
            .attr("startOffset", hPosition)
            .attr('xlink:href', (d, i) => "#edgepath-" + d.source + "-" + d.target)
            .style("pointer-events", "none");

        g.selectAll(".edgelabels")
            .data(links)
            .enter()
            .append('text')
            .attr("class", "text edgelabels")
            .attr("dy", 4)
            .attr("font-size", "14px")
            .style("pointer-events", "none")
            .style("text-anchor", "middle")
            .append('textPath')
            .text((d, i) => d.value)
            .attr("startOffset", hPosition)
            .attr('xlink:href', (d, i) => "#edgepath-" + d.source + "-" + d.target)
            .style("pointer-events", "none");
    };
    const drawTofEdges = (nOfTofsPerPlane, tofLinks, g, colorMap) => {
        if (nOfTofsPerPlane <= 2)
            drawEdges(tofLinks, g, colorMap, "50%");

        const notHLinks = [];
        const hLinks = [];
        tofLinks.forEach((x) => {
            const sourceTofFirstNumber = x.source.split('_')[1];
            const targetTofFirstNumber = x.target.split('_')[1];

            if (Math.abs(targetTofFirstNumber - sourceTofFirstNumber) == 1)
                hLinks.push(x);
            else
                notHLinks.push(x);
        });

        drawEdges(hLinks, g, colorMap, "50%");
        notHLinks.forEach((link) => {
            const sourceNode = findNode(link.source);
            const targetNode = findNode(link.target);

            const sourceLineY = sourceNode.y - 40;
            const targetLineY = targetNode.y - 40;

            g.append("line")
                .attr("x1", sourceNode.x)
                .attr("y1", sourceNode.y)
                .attr("x2", sourceNode.x)
                .attr("y2", sourceLineY)
                .attr("stroke-width", 1)
                .attr("stroke", colorMap[Math.round(colorScale(link.value))]);

            g.append("line")
                .attr("x1", targetNode.x)
                .attr("y1", targetNode.y)
                .attr("x2", targetNode.x)
                .attr("y2", targetLineY)
                .attr("stroke-width", 1)
                .attr("stroke", colorMap[Math.round(colorScale(link.value))]);

            g.append("line")
                .attr("x1", sourceNode.x)
                .attr("y1", sourceLineY)
                .attr("x2", targetNode.x)
                .attr("y2", targetLineY)
                .attr("stroke-width", 1)
                .attr("stroke", colorMap[Math.round(colorScale(link.value))]);

            g.append('path')
                .attr("d", 'M ' + sourceNode.x + ' ' + sourceLineY + ' L ' + targetNode.x + ' ' + targetLineY)
                .attr("fill-opacity", 0)
                .attr("stroke-opacity", 0)
                .attr("id", "edgepath-" + link.source + "-" + link.target)
                .style("pointer-events", "none");

            g.append('text')
                .attr("class", "text")
                .attr("dy", 4)
                .attr("stroke", "white")
                .attr("stroke-width", 3)
                .attr("fill", "white")
                .attr("font-size", "14px")
                .style("pointer-events", "none")
                .style("text-anchor", "middle")
                .append('textPath')
                .text(link.value)
                .attr("startOffset", "50%")
                .attr('xlink:href', "#edgepath-" + link.source + "-" + link.target)
                .style("pointer-events", "none");

            g.append('text')
                .attr("class", "text")
                .attr("dy", 4)
                .attr("font-size", "14px")
                .style("pointer-events", "none")
                .style("text-anchor", "middle")
                .append('textPath')
                .text(link.value)
                .attr("startOffset", "50%")
                .attr('xlink:href', "#edgepath-" + link.source + "-" + link.target)
                .style("pointer-events", "none");
        });
    };
    const getNodeColor = (node, tofColorMap) => {
        if (node.includes("tof")) {
            const tofName = node.split("_");
            return tofColorMap[Math.round(tofColorScale(tofName[1]))]
        }

        return "#1034a6";
    };
</script>

<script>
    const rectSizeX = 100, rectSizeY = 35;

    const failedNode = "%FAILED_NODE%";
    const failedNeighbours = "%FAILED_NEIGHBOURS%";
    const isNormalStarting = "%IS_NORMAL_STARTING%";
    const nOfPlanes = "%N_PLANES%";
    const data = "%GRAPH%";

    const [maxX, maxY] = computePositions(data);
    filterLinks(data);

    const links = data.links.filter((x) => !x.isTofRing);
    const tofRingLinks = data.links.filter((x) => x.isTofRing);

    const colorMap = ["#57bb8a", "#63b682", "#73b87e", "#84bb7b", "#94bd77", "#a4c073", "#b0be6e", "#c4c56d", "#d4c86a", "#e2c965", "#f5ce62", "#f3c563", "#e9b861", "#e6ad61", "#ecac67", "#e9a268", "#e79a69", "#e5926b", "#e2886c", "#e0816d", "#dd776e"];
    const valuesDomain = Array(Math.max.apply(null, data.links.map(x => x.value)) + 1).fill(0).map((x, y) => y);
    const colorScale = d3.scalePoint()
        .domain(valuesDomain)
        .range([0, colorMap.length - 1]);

    const tofColorMap = ["#6e40aa", "#6d41ab", "#6d41ad", "#6d42ae", "#6c43af", "#6c43b0", "#6b44b2", "#6b45b3", "#6a46b4", "#6a46b5", "#6a47b7", "#6948b8", "#6849b9", "#684aba", "#674abb", "#674bbd", "#664cbe", "#664dbf", "#654ec0", "#654fc1", "#6450c2", "#6350c3", "#6351c4", "#6252c5", "#6153c6", "#6154c7", "#6055c8", "#5f56c9", "#5f57ca", "#5e58cb", "#5d59cc", "#5c5acd", "#5c5bce", "#5b5ccf", "#5a5dd0", "#595ed1", "#595fd1", "#5860d2", "#5761d3", "#5662d4", "#5663d5", "#5564d5", "#5465d6", "#5366d7", "#5267d7", "#5168d8", "#5169d9", "#506ad9", "#4f6bda", "#4e6cda", "#4d6ddb", "#4c6edb", "#4b70dc", "#4b71dc", "#4a72dd", "#4973dd", "#4874de", "#4775de", "#4676df", "#4577df", "#4479df", "#447adf", "#437be0", "#427ce0", "#417de0", "#407ee0", "#3f80e1", "#3e81e1", "#3d82e1", "#3d83e1", "#3c84e1", "#3b86e1", "#3a87e1", "#3988e1", "#3889e1", "#378ae1", "#378ce1", "#368de1", "#358ee1", "#348fe1", "#3390e1", "#3292e1", "#3293e1", "#3194e0", "#3095e0", "#2f96e0", "#2e98e0", "#2e99df", "#2d9adf", "#2c9bdf", "#2b9cde", "#2b9ede", "#2a9fdd", "#29a0dd", "#29a1dd", "#28a2dc", "#27a4dc", "#26a5db", "#26a6db", "#25a7da", "#25a8d9", "#24aad9", "#23abd8", "#23acd8", "#22add7", "#22aed6", "#21afd5", "#21b1d5", "#20b2d4", "#20b3d3", "#1fb4d2", "#1fb5d2", "#1eb6d1", "#1eb8d0", "#1db9cf", "#1dbace", "#1dbbcd", "#1cbccc", "#1cbdcc", "#1cbecb", "#1bbfca", "#1bc0c9", "#1bc2c8", "#1ac3c7", "#1ac4c6", "#1ac5c5", "#1ac6c4", "#1ac7c2", "#1ac8c1", "#19c9c0", "#19cabf", "#19cbbe", "#19ccbd", "#19cdbc", "#19cebb", "#19cfb9", "#19d0b8", "#19d1b7", "#19d2b6", "#19d3b5", "#1ad4b4", "#1ad5b2", "#1ad5b1", "#1ad6b0", "#1ad7af", "#1bd8ad", "#1bd9ac", "#1bdaab", "#1bdbaa", "#1cdba8", "#1cdca7", "#1cdda6", "#1ddea4", "#1ddfa3", "#1edfa2", "#1ee0a0", "#1fe19f", "#1fe29e", "#20e29d", "#20e39b", "#21e49a", "#22e599", "#22e597", "#23e696", "#24e795", "#24e793", "#25e892", "#26e891", "#27e98f", "#27ea8e", "#28ea8d", "#29eb8c", "#2aeb8a", "#2bec89", "#2cec88", "#2ded87", "#2eed85", "#2fee84", "#30ee83", "#31ef82", "#32ef80", "#33f07f", "#34f07e", "#35f07d", "#37f17c", "#38f17a", "#39f279", "#3af278", "#3bf277", "#3df376", "#3ef375", "#3ff374", "#41f373", "#42f471", "#43f470", "#45f46f", "#46f46e", "#48f56d", "#49f56c", "#4bf56b", "#4cf56a", "#4ef56a", "#4ff669", "#51f668", "#52f667", "#54f666", "#55f665", "#57f664", "#59f664", "#5af663", "#5cf662", "#5ef661", "#5ff761", "#61f760", "#63f75f", "#64f75f", "#66f75e", "#68f75d", "#6af75d", "#6bf65c", "#6df65c", "#6ff65b", "#71f65b", "#73f65a", "#74f65a", "#76f659", "#78f659", "#7af659", "#7cf658", "#7ef658", "#80f558", "#81f558", "#83f557", "#85f557", "#87f557", "#89f557", "#8bf457", "#8df457", "#8ff457", "#91f457", "#93f457", "#94f357", "#96f357", "#98f357", "#9af357", "#9cf257", "#9ef258", "#a0f258", "#a2f258", "#a4f158", "#a6f159", "#a8f159", "#aaf159", "#abf05a", "#adf05a", "#aff05b"];
    const tofValuesDomain = Array(nOfPlanes).fill(0).map((x, y) => y + 1);
    const tofColorScale = d3.scalePoint()
        .domain(tofValuesDomain)
        .range([0, tofColorMap.length - 1]);

    const network = d3.select('#network');

    const svg = network.append('svg')
        .attr('width', "100%")
        .attr('height', "100%")
        .attr("viewBox", [0, 0, maxX, maxY])
        .call(d3.zoom()
            .on("zoom", () => {
                g.attr("transform", d3.event.transform);
            })
        );

    const g = svg.append('g')
        .attr('width', "100%")
        .attr('height', "100%");

    drawEdges(links, g, colorMap, "20%");
    drawTofEdges(data.nOfTofsPerPlane, tofRingLinks, g, colorMap);

    g.selectAll(".nodes")
        .data(data.nodes)
        .enter()
        .append("rect")
        .attr("class", "nodes")
        .attr("x", (d) => centerX(d.x))
        .attr("y", (d) => centerY(d.y))
        .attr("width", (d) => rectSizeX)
        .attr("height", (d) => rectSizeY)
        .attr("fill", (d) => d.label === failedNode ? (!isNormalStarting ? "#b80f0a" : "#228b22") : getNodeColor(d.label, tofColorMap))
        .attr("fill-opacity", 0.95);

    g.selectAll(".nodelabels-shadow")
        .data(data.nodes)
        .enter()
        .append("text")
        .text((d) => d.label)
        .attr("class", "text nodelabels-shadow")
        .attr("x", (d) => d.x)
        .attr("y", (d) => d.y)
        .attr("dy", "3px")
        .attr("stroke", "black")
        .attr("stroke-width", 2)
        .attr("fill", "black")
        .style("text-anchor", "middle");

    g.selectAll(".nodelabels")
        .data(data.nodes)
        .enter()
        .append("text")
        .text((d) => d.label)
        .attr("class", "text nodelabels")
        .attr("x", (d) => d.x)
        .attr("y", (d) => d.y)
        .attr("dy", "3px")
        .attr("fill", "white")
        .style("text-anchor", "middle");
</script>
</body>
</html>